libapreq2-2.05-dev: libapreq2: include/apreq.h File Reference

Apache HTTP Server Request Library

Main Page | Modules | Data Structures | Directories | File List | Data Fields | Globals | Related Pages

# apreq.h File Reference

Main header file... More...

`#include "apr_tables.h"`
`#include <stddef.h>`

Go to the source code of this file.

## Defines
#define | APREQ_DECLARE(d) APR_DECLARE(d)
#define | APREQ_DECLARE_NONSTD(d) APR_DECLARE_NONSTD(d)
#define | APREQ_DECLARE_DATA
#define | APREQ_DEFAULT_READ_BLOCK_SIZE (64 * 1024)
#define | APREQ_DEFAULT_READ_LIMIT (64 * 1024 * 1024)
#define | APREQ_DEFAULT_BRIGADE_LIMIT (256 * 1024)
#define | APREQ_DEFAULT_NELTS 8
#define | APREQ_FLAGS_OFF(f, name) ((f) &= ~(name##_MASK << name##_BIT))
#define | APREQ_FLAGS_ON(f, name) ((f) |= (name##_MASK << name##_BIT))
#define | APREQ_FLAGS_GET(f, name) (((f) >> name##_BIT) & name##_MASK)
#define | APREQ_FLAGS_SET(f, name, value)
#define | APREQ_CHARSET_BIT 0
#define | APREQ_CHARSET_MASK 255
#define | APREQ_TAINTED_BIT 8
#define | APREQ_TAINTED_MASK 1
#define | APREQ_COOKIE_VERSION_BIT 11
#define | APREQ_COOKIE_VERSION_MASK 3
#define | APREQ_COOKIE_SECURE_BIT 13
#define | APREQ_COOKIE_SECURE_MASK 1
#define | apreq_attr_to_type(T, A, P) ( (T*) ((char*)(P)-offsetof(T,A)) )
## Typedefs
typedef apreq_value_t | apreq_value_t
| libapreq's pre-extensible string type
## Enumerations
enum | apreq_charset_t { APREQ_CHARSET_ASCII = 0, APREQ_CHARSET_LATIN1 = 1, APREQ_CHARSET_CP1252 = 2, APREQ_CHARSET_UTF8 = 8 }
enum | apreq_join_t { APREQ_JOIN_AS_IS, APREQ_JOIN_ENCODE, APREQ_JOIN_DECODE, APREQ_JOIN_QUOTE }
enum | apreq_match_t { APREQ_MATCH_FULL, APREQ_MATCH_PARTIAL }
enum | apreq_expires_t { APREQ_EXPIRES_HTTP, APREQ_EXPIRES_NSCOOKIE }
## Functions
static APR_INLINE void | apreq_value_table_add (const apreq_value_t *v, apr_table_t *t)
apr_status_t | apreq_initialize (apr_pool_t *pool)
apr_status_t | apreq_pre_initialize (apr_pool_t *pool)
apr_status_t | apreq_post_initialize (apr_pool_t *pool)

## Detailed Description

Main header file...

Define the generic APREQ_ macros and common data structures.

## Define Documentation

#define APREQ_FLAGS_SET | ( | f,
|  | name,
|  | value |  | ) |

| Value:
    ((f) = (((f) & ~(name##_MASK << name##_BIT))        \
                | ((name##_MASK & (value)) << name##_BIT)))

## Enumeration Type Documentation

enum apreq_charset_t

| Character encodings.

enum apreq_expires_t

  | Expiration date format Enumeration values:
  APREQ_EXPIRES_HTTP | Use date formatting consistent with RFC 2616
  APREQ_EXPIRES_NSCOOKIE | Use format consistent with Netscape's Cookie Spec

enum apreq_join_t

  | Join type Enumeration values:
  APREQ_JOIN_AS_IS | Join the strings without modification
  APREQ_JOIN_ENCODE | Url-encode the strings before joining them
  APREQ_JOIN_DECODE | Url-decode the strings before joining them
  APREQ_JOIN_QUOTE | Quote the strings, backslashing existing quote marks.

enum apreq_match_t

  | Match type Enumeration values:
  APREQ_MATCH_FULL | Full match only.
  APREQ_MATCH_PARTIAL | Partial matches are ok.

## Function Documentation

apr_status_t apreq_initialize | ( | apr_pool_t * | pool | ) |

  | Initialize libapreq2. Applications (except apache modules using mod_apreq) should call this exactly once before they use any libapreq2 modules. If you want to modify the list of default parsers with apreq_register_parser(), please use apreq_pre_initialize() and apreq_post_initialize() instead. Parameters:
  | pool | a base pool persisting while libapreq2 is used
Remarks: after you detroy the pool, you have to call this function again with a new pool if you still plan to use libapreq2

apr_status_t apreq_post_initialize | ( | apr_pool_t * | pool | ) |

  | Post-initialize libapreq2. Applications (except apache modules using mod_apreq2) should this exactly once before they use any libapreq2 modules for parsing. Parameters:
  | pool | the same pool that was used in apreq_pre_initialize().

apr_status_t apreq_pre_initialize | ( | apr_pool_t * | pool | ) |

  | Pre-initialize libapreq2. Applications (except apache modules using mod_apreq2) should call this exactly once before they register custom parsers with libapreq2. mod_apreq2 does this automatically during the post-config phase, so modules that need call apreq_register_parser should create a post-config hook using APR_HOOK_MIDDLE. Parameters:
  | pool | a base pool persisting while libapreq2 is used
Remarks: after you detroyed the pool, you have to call this function again with a new pool if you still plan to use libapreq2